/*
 * Creator: Naman Dixit
 * Notice: © Copyright 2022 Naman Dixit
 */

#include <cerrno>

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <memory>

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-parameter"
#pragma clang diagnostic ignored "-Wc++98-compat-pedantic"
#pragma clang diagnostic ignored "-Wold-style-cast"
#pragma clang diagnostic ignored "-Wmissing-variable-declarations"
#pragma clang diagnostic ignored "-Wdocumentation-unknown-command"
#pragma clang diagnostic ignored "-Wsign-conversion"
#pragma clang diagnostic ignored "-Wimplicit-int-conversion"
#pragma clang diagnostic ignored "-Wshorten-64-to-32"
#pragma clang diagnostic ignored "-Wshadow-field"
#pragma clang diagnostic ignored "-Wpadded"
#pragma clang diagnostic ignored "-Wcomma"
#pragma clang diagnostic ignored "-Wextra-semi-stmt"
#pragma clang diagnostic ignored "-Wshadow"
#pragma clang diagnostic ignored "-Wmissing-noreturn"
#pragma clang diagnostic ignored "-Wsigned-enum-bitfield"
#pragma clang diagnostic ignored "-Wswitch-enum"
#pragma clang diagnostic ignored "-Wzero-as-null-pointer-constant"
#pragma clang diagnostic ignored "-Wextra-semi"
#pragma clang diagnostic ignored "-Wdeprecated-copy-with-dtor"
#pragma clang diagnostic ignored "-Wexit-time-destructors"
#pragma clang diagnostic ignored "-Wglobal-constructors"
#pragma clang diagnostic ignored "-Wsuggest-destructor-override"
#pragma clang diagnostic ignored "-Winconsistent-missing-destructor-override"
#pragma clang diagnostic ignored "-Wweak-vtables"
#pragma clang diagnostic ignored "-Wundefined-func-template"
#pragma clang diagnostic ignored "-Wreserved-identifier"
#pragma clang diagnostic ignored "-Wenum-enum-conversion"
#pragma clang diagnostic ignored "-Wcast-align"
#pragma clang diagnostic ignored "-Wduplicate-enum"
#pragma clang diagnostic ignored "-Wbitfield-enum-conversion"
#pragma clang diagnostic ignored "-Wused-but-marked-unused"
#pragma clang diagnostic ignored "-Wdocumentation"
#pragma clang diagnostic ignored "-Wformat-nonliteral"

#define DONT_GET_PLUGIN_LOADER_OPTION

#include <llvm/ADT/StringExtras.h>
#include <llvm/ADT/Triple.h>
#include "llvm/Analysis/CallGraph.h"
#include "llvm/Analysis/CallGraphSCCPass.h"
#include "llvm/Analysis/LoopPass.h"
#include "llvm/Analysis/RegionPass.h"
#include "llvm/Analysis/TargetLibraryInfo.h"
#include "llvm/Analysis/TargetTransformInfo.h"
#include "llvm/AsmParser/Parser.h"
#include <llvm/Bitcode/BitcodeReader.h>
#include <llvm/CodeGen/CommandFlags.h>
#include <llvm/CodeGen/LinkAllCodegenComponents.h>
#include "llvm/CodeGen/TargetPassConfig.h"
#include <llvm/Config/llvm-config.h>
#include <llvm/ExecutionEngine/GenericValue.h>
#include <llvm/ExecutionEngine/Interpreter.h>
#include <llvm/ExecutionEngine/SectionMemoryManager.h>
#include "llvm/IR/DataLayout.h"
#include "llvm/IR/DebugInfo.h"
#include <llvm/IR/IRBuilder.h>
#include <llvm/IR/LLVMContext.h>
#include "llvm/IR/LLVMRemarkStreamer.h"
#include "llvm/IR/LegacyPassManager.h"
#include "llvm/IR/LegacyPassNameParser.h"
#include <llvm/IR/Module.h>
#include <llvm/IR/Type.h>
#include <llvm/IR/Verifier.h>
#include <llvm/IR/AssemblyAnnotationWriter.h>
#include <llvm/IRReader/IRReader.h>
#include "llvm/InitializePasses.h"
#include "llvm/LinkAllIR.h"
#include "llvm/LinkAllPasses.h"
#include "llvm/MC/SubtargetFeature.h"
#include <llvm/Object/Archive.h>
#include <llvm/Object/ObjectFile.h>
#include "llvm/Remarks/HotnessThresholdParser.h"
#include <llvm/Support/CommandLine.h>
#include <llvm/Support/Debug.h>
#include <llvm/Support/DynamicLibrary.h>
#include "llvm/Support/FileSystem.h"
#include <llvm/Support/Format.h>
#include "llvm/Support/Host.h"
#include <llvm/Support/InitLLVM.h>
#include <llvm/Support/ManagedStatic.h>
#include <llvm/Support/MathExtras.h>
#include <llvm/Support/Memory.h>
#include <llvm/Support/MemoryBuffer.h>
#include <llvm/Support/Path.h>
#include "llvm/Support/PluginLoader.h"
#include <llvm/Support/Process.h>
#include <llvm/Support/Program.h>
#include <llvm/Support/SourceMgr.h>
#include "llvm/Support/SystemUtils.h"
#include "llvm/Support/TargetRegistry.h"
#include <llvm/Support/TargetSelect.h>
#include "llvm/Support/ToolOutputFile.h"
#include <llvm/Support/WithColor.h>
#include <llvm/Support/raw_ostream.h>
#include "llvm/Support/YAMLTraits.h"
#include "llvm/Target/TargetMachine.h"
#include "llvm/Transforms/Coroutines.h"
#include <llvm/Transforms/Instrumentation.h>
#include "llvm/Transforms/IPO/AlwaysInliner.h"
#include "llvm/Transforms/IPO/PassManagerBuilder.h"
#include "llvm/Transforms/IPO/WholeProgramDevirt.h"
#include "llvm/Transforms/Utils/Cloning.h"
#include "llvm/Transforms/Utils/Debugify.h"

#include <clang/Lex/PreprocessorOptions.h>
#include <clang/Frontend/CompilerInstance.h>
#include <clang/Basic/DiagnosticOptions.h>
#include <clang/Frontend/TextDiagnosticPrinter.h>
#include <clang/CodeGen/CodeGenAction.h>
#include <clang/Basic/TargetInfo.h>

#undef DONT_GET_PLUGIN_LOADER_OPTION

#pragma clang diagnostic pop

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#pragma clang diagnostic ignored "-Wexit-time-destructors"
static llvm::codegen::RegisterCodeGenFlags GLOBAL_code_gen_flags;
#pragma clang diagnostic pop

static
llvm::TargetMachine* GetTargetMachine (llvm::Triple TheTriple,
                                       [[maybe_unused]] llvm::StringRef CPUStr,
                                       [[maybe_unused]] llvm::StringRef FeaturesStr,
                                       const llvm::TargetOptions &Options)
{
    std::string Error;
    const llvm::Target *TheTarget =
        llvm::TargetRegistry::lookupTarget(llvm::codegen::getMArch(), TheTriple, Error);
    // Some modules don't specify a triple, and this is okay.
    if (!TheTarget) {
        return nullptr;
    }

    return TheTarget->createTargetMachine(TheTriple.getTriple(),
                                          llvm::codegen::getCPUStr(),
                                          llvm::codegen::getFeaturesStr(),
                                          Options,
                                          llvm::codegen::getExplicitRelocModel(),
                                          llvm::codegen::getExplicitCodeModel(),
                                          llvm::CodeGenOpt::None);
}

int main(int argc, char *argv[], char * const *envp) {
    std::string code_name = "test.c";
    std::string code = R"END(
#include <stdio.h>
int main (void)
{
        printf("Hello, World!\n");
        return 42;
}
)END";




    llvm::InitLLVM llvm(argc, argv);

    llvm::EnableDebugBuffering = true;

    llvm::ExitOnError exit_on_err;
    exit_on_err.setBanner("Error: ");

    llvm::InitializeNativeTarget();
    llvm::InitializeNativeTargetAsmPrinter();
    llvm::InitializeNativeTargetAsmParser();



    // Prepare compilation arguments
    std::vector<const char *> compiler_args;
    compiler_args.push_back(code_name.c_str());

    // Prepare DiagnosticEngine
    clang::DiagnosticOptions diagnostics_options;
    clang::TextDiagnosticPrinter *diagnostics_printer = new clang::TextDiagnosticPrinter(llvm::errs(),
                                                                                         &diagnostics_options);
    clang::IntrusiveRefCntPtr<clang::DiagnosticIDs> diagnostics_id_ptr;
    clang::DiagnosticsEngine *diagnostics_engine = new clang::DiagnosticsEngine(diagnostics_id_ptr,
                                                                                &diagnostics_options,
                                                                                diagnostics_printer);

    clang::CompilerInvocation *compiler_invoke = new clang::CompilerInvocation();
    compiler_args.push_back("-resource-dir");
    compiler_args.push_back("/usr/lib/llvm-10/lib/clang/10.0.0");
    compiler_args.push_back("-internal-isystem");
    compiler_args.push_back("/usr/local/include");
    compiler_args.push_back("-internal-isystem");
    compiler_args.push_back("/usr/lib/llvm-10/lib/clang/10.0.0/include");
    compiler_args.push_back("-internal-externc-isystem");
    compiler_args.push_back("/usr/include/x86_64-linux-gnu");
    compiler_args.push_back("-internal-externc-isystem");
    compiler_args.push_back("/include");
    compiler_args.push_back("-internal-externc-isystem");
    compiler_args.push_back("/usr/include");

    llvm::ArrayRef<const char*> compiler_args_array(compiler_args);
    clang::CompilerInvocation::CreateFromArgs(*compiler_invoke, compiler_args_array, *diagnostics_engine);

    llvm::StringRef code_data(code);
    std::unique_ptr<llvm::MemoryBuffer> compiler_buffer = llvm::MemoryBuffer::getMemBufferCopy(code_data);
    compiler_invoke->getPreprocessorOpts().addRemappedFile(code_name, compiler_buffer.get());

    clang::CompilerInstance compiler_instance;
    std::shared_ptr<clang::CompilerInvocation> compiler_invoke_shared_ptr(compiler_invoke);
    compiler_instance.setInvocation(compiler_invoke_shared_ptr);
    compiler_instance.createDiagnostics();

    const std::shared_ptr<clang::TargetOptions> compiler_target_options = std::make_shared<clang::TargetOptions>();
    compiler_target_options->Triple = std::string("bpf");
    clang::TargetInfo *compiler_target_info = clang::TargetInfo::CreateTargetInfo(*diagnostics_engine,
                                                                                  compiler_target_options);
    compiler_instance.setTarget(compiler_target_info);

    clang::CodeGenAction *compiler_action = new clang::EmitLLVMOnlyAction();
    compiler_instance.ExecuteAction(*compiler_action);





    llvm::InitializeAllTargets();
    llvm::InitializeAllTargetMCs();
    llvm::InitializeAllAsmPrinters();
    llvm::InitializeAllAsmParsers();

    // Initialize passes
    llvm::PassRegistry &Registry = *llvm::PassRegistry::getPassRegistry();
    llvm::initializeCore(Registry);
    llvm::initializeCoroutines(Registry);
    llvm::initializeScalarOpts(Registry);
    llvm::initializeObjCARCOpts(Registry);
    llvm::initializeVectorization(Registry);
    llvm::initializeIPO(Registry);
    llvm::initializeAnalysis(Registry);
    llvm::initializeTransformUtils(Registry);
    llvm::initializeInstCombine(Registry);
    llvm::initializeAggressiveInstCombine(Registry);
    llvm::initializeInstrumentation(Registry);
    llvm::initializeTarget(Registry);
    // For codegen passes, only passes that do IR to IR transformation are
    // supported.
    llvm::initializeExpandMemCmpPassPass(Registry);
    llvm::initializeScalarizeMaskedMemIntrinLegacyPassPass(Registry);
    llvm::initializeCodeGenPreparePass(Registry);
    llvm::initializeAtomicExpandPass(Registry);
    llvm::initializeRewriteSymbolsLegacyPassPass(Registry);
    llvm::initializeWinEHPreparePass(Registry);
    llvm::initializeDwarfEHPrepareLegacyPassPass(Registry);
    llvm::initializeSafeStackLegacyPassPass(Registry);
    llvm::initializeSjLjEHPreparePass(Registry);
    llvm::initializePreISelIntrinsicLoweringLegacyPassPass(Registry);
    llvm::initializeGlobalMergePass(Registry);
    llvm::initializeIndirectBrExpandPassPass(Registry);
    llvm::initializeInterleavedLoadCombinePass(Registry);
    llvm::initializeInterleavedAccessPass(Registry);
    llvm::initializeEntryExitInstrumenterPass(Registry);
    llvm::initializePostInlineEntryExitInstrumenterPass(Registry);
    llvm::initializeUnreachableBlockElimLegacyPassPass(Registry);
    llvm::initializeExpandReductionsPass(Registry);
    llvm::initializeExpandVectorPredicationPass(Registry);
    llvm::initializeWasmEHPreparePass(Registry);
    llvm::initializeWriteBitcodePassPass(Registry);
    llvm::initializeHardwareLoopsPass(Registry);
    llvm::initializeTypePromotionPass(Registry);
    llvm::initializeReplaceWithVeclibLegacyPass(Registry);



    llvm::LLVMContext Context;

    Context.setDiscardValueNames(false);
    Context.enableDebugTypeODRUniquing();

    llvm::SMDiagnostic Err;
    std::unique_ptr<llvm::Module> Owner = compiler_action->takeModule();
    llvm::Module *Mod = Owner.get();
    if (!Mod) {
        Err.print(code_name.c_str(), llvm::errs());
        exit(1);
    }

    if (llvm::verifyModule(*Mod, &llvm::errs())) {
        llvm::errs() << "error: input module is broken!\n";
        return 1;
    }

    {
        llvm::ExitOnError eoe(std::string(code_name) +
                              ": bitcode didn't read correctly: ");
        eoe(Mod->materializeAll());
    }

    llvm::updateVCallVisibilityInModule(*Mod,
                                        /* WholeProgramVisibilityEnabledInLTO */ false,
                                        /* DynamicExportSymbols */ {});

    llvm::Triple ModuleTriple(Mod->getTargetTriple());
    const llvm::TargetOptions Options = llvm::codegen::InitTargetOptionsFromCodeGenFlags(ModuleTriple);
    std::string CPUStr, FeaturesStr;
    llvm::TargetMachine *Machine = nullptr;
    if (ModuleTriple.getArch()) {
        CPUStr = llvm::codegen::getCPUStr();
        FeaturesStr = llvm::codegen::getFeaturesStr();
        Machine = GetTargetMachine(ModuleTriple, CPUStr, FeaturesStr, Options);
    } else if (ModuleTriple.getArchName() != "unknown" &&
               ModuleTriple.getArchName() != "") {
        llvm::errs() << "unrecognized architecture '"
               << ModuleTriple.getArchName() << "' provided.\n";
        return 1;
    }

    std::unique_ptr<llvm::TargetMachine> TM(Machine);
    llvm::codegen::setFunctionAttributes(CPUStr, FeaturesStr, *Mod);

    llvm::TargetLibraryInfoImpl TLII(ModuleTriple);

    { // Simplify LibCalls
        llvm::LibFunc F;
        // TODO(naman): Explore this, what does disabling functions actually means?
        std::list<std::string> DisableBuiltins = {}; // Empty for now, further research necessary
        for (auto &FuncName : DisableBuiltins)
            if (TLII.getLibFunc(FuncName, F))
                TLII.setUnavailable(F);
            else {
                llvm::errs() << "cannot disable nonexistent builtin function "
                       << FuncName << '\n';
                return 1;
            }
    }

    llvm::DebugifyCustomPassManager Passes;
    DebugifyStatsMap DIStatsMap;
    DebugInfoPerPassMap DIPreservationMap;
    Passes.add(new llvm::TargetLibraryInfoWrapperPass(TLII));
    Passes.add(createTargetTransformInfoWrapperPass(TM ?
                                                    TM->getTargetIRAnalysis()
                                                    : llvm::TargetIRAnalysis()));

    if (TM) {
        // FIXME: We should dyn_cast this when supported.
        auto &LTM = static_cast<llvm::LLVMTargetMachine &>(*TM);
        llvm::Pass *TPC = LTM.createPassConfig(Passes);
        Passes.add(TPC);
    }

    std::list<const PassInfo *> PassList;

    for (unsigned i = 0; i < PassList.size(); ++i) {
        const llvm::PassInfo *PassInf = PassList[i];
        llvm::Pass *P = nullptr;
        if (PassInf->getNormalCtor())
            P = PassInf->getNormalCtor()();
        else
            llvm::errs() << argv[0] << ": cannot create pass: "
                   << PassInf->getPassName() << "\n";
        if (P) {
            Passes.add(P);
        }
    }















    std::unique_ptr<llvm::AssemblyAnnotationWriter> Annotator;
    std::string dis_str;
    llvm::raw_string_ostream dis_stream(dis_str);
    Mod->print(dis_stream, Annotator.get());
    std::cout << std::endl << std::endl << "\033[1;34m" << dis_str << std::endl << "\033[0m" << std::endl;





    std::string ErrorMsg;

    llvm::EngineBuilder builder(std::move(Owner));

    builder.setErrorStr(&ErrorMsg);

    builder.setMArch(llvm::codegen::getMArch());
    builder.setMCPU(llvm::codegen::getCPUStr());
    builder.setMAttrs(llvm::codegen::getFeatureList());

    if (auto RM = llvm::codegen::getExplicitRelocModel()) {
        builder.setRelocationModel(RM.getValue());
    }

    if (auto CM = llvm::codegen::getExplicitCodeModel()) {
        builder.setCodeModel(CM.getValue());
    }

    builder.setEngineKind(llvm::EngineKind::Interpreter);

    builder.setOptLevel(llvm::CodeGenOpt::None);

    llvm::TargetOptions Options_EE = llvm::codegen::InitTargetOptionsFromCodeGenFlags(llvm::Triple());
    if (llvm::codegen::getFloatABIForCalls() != llvm::FloatABI::Default) {
        Options_EE.FloatABIType = llvm::codegen::getFloatABIForCalls();
    }

    builder.setTargetOptions(Options_EE);


    std::unique_ptr<llvm::ExecutionEngine> EE(builder.create());
    if (!EE) {
        if (!ErrorMsg.empty())
            llvm::WithColor::error(llvm::errs(), code_name)
                << "error creating EE: " << ErrorMsg << "\n";
        else
            llvm::WithColor::error(llvm::errs(), code_name) << "unknown error creating EE!\n";
        exit(1);
    }

    EE->DisableLazyCompilation(false);

    if (llvm::StringRef(code_name).endswith(".bc"))
        code_name.erase(code_name.length() - 3);

    llvm::Function *EntryFn = Mod->getFunction("main");
    if (!EntryFn) {
        llvm::WithColor::error(llvm::errs(), code_name.c_str())
            << '\'' << "main" << "\' function not found in module.\n";
        return -1;
    }

    errno = 0;

    int Result = -1;

    llvm::FunctionCallee Exit = Mod->getOrInsertFunction("exit",
                                                         llvm::Type::getVoidTy(Context),
                                                         llvm::Type::getInt32Ty(Context));
    EE->runStaticConstructorsDestructors(false);
    (void)EE->getPointerToFunction(EntryFn);

    // Run main.
    Result = EE->runFunctionAsMain(EntryFn, std::vector<std::string>(), envp);

    // Run static destructors.
    EE->runStaticConstructorsDestructors(true);

    if (llvm::Function *ExitF =
        llvm::dyn_cast<llvm::Function>(Exit.getCallee()->stripPointerCasts())) {
        if (ExitF->getFunctionType() == Exit.getFunctionType()) {
            std::vector<llvm::GenericValue> Args;
            llvm::GenericValue ResultGV;
            ResultGV.IntVal = llvm::APInt(32, static_cast<uint64_t>(Result));
            Args.push_back(ResultGV);
            EE->runFunction(ExitF, Args);
            llvm::WithColor::error(llvm::errs(), code_name.c_str())
                << "exit(" << Result << ") returned!\n";
            abort();
        }
    }

    llvm::WithColor::error(llvm::errs(), code_name.c_str()) << "exit defined with wrong prototype!\n";
    abort();

    //return Result;
}
